//
//  Copyright(C) 1997,1998 NEC Corporation
//	All rights reserved.
//	Author: Mizukoshi, Yasuhiro
//	E-Mail: pochi@ccs.mt.nec.co.jp
//

#include <windows.h>
#include <tchar.h>
#include "resource.h"

#define WM_OTPCE_NOTIFY		(WM_USER+100)
#define WM_PASSPHRASE		(WM_USER+101)
#define WM_OTPCE_OPT		(WM_USER+102)

#define DIALOG_MODE_OPT		TEXT("/dlg")
#define DIALOG_MODE			0x1

#define IDT_OTPCE			100
#define OTPCE_NAME			TEXT("otpCE")
#define OTPCE_ICON			TEXT("OTPCEICON")

#define	MENU_X_MARGIN		144
#define	MENU_Y_MARGIN		32
#define	IDM_EXIT			200
#define	IDM_SKEYMD5			201
#define	SKEYMD5_MENU		TEXT("&S/Key MD5")
#define	EXIT_MENU			TEXT("E&xit")

#define OTPCE_SUBKEY		TEXT("Software\\NEC\\otpCE")
#define SKEYMD5_VALNAME		TEXT("bSKeyMD5")

#define PASS_PHRASE_MIN_LEN	8
#define PASS_PHRASE_MAX_LEN	256
#define SEED_MAX_LEN		1024
#define ONETIME_KEY_MAX_LEN	256

#define CRLF				TEXT("\r\n")

//	RFC 1938
#define OTPMD4				TEXT("otp-md4")
#define OTPMD5				TEXT("otp-md5")
#define OTPSHA1				TEXT("otp-sha1")
//	RFC 1760
#define SKEY				TEXT("s/key")
//	BSD/OS 
#define BSDOS_SKEYMD4		TEXT("S/Key MD4")
#define BSDOS_SKEYMD5		TEXT("S/Key MD5")

#define FUNCNAME_MD2		TEXT("md2")
#define FUNCNAME_MD4		TEXT("md4")
#define FUNCNAME_MD5		TEXT("md5")
#define FUNCNAME_SHA1		TEXT("sha1")

#define MD2					0
#define MD4					1
#define MD5					2
#define SHA1				3

#define BUF_SIZE			512

int TrayAdd(HWND hWnd);
int TrayDelete(HWND hWnd);
BOOL LoadRegistory();
BOOL SaveRegistory();

int CalcOTP(HWND hWnd);
int FindSeq(LPTSTR buffer);
int SetFuncName();
LPTSTR ScanBuf(LPTSTR p, LPTSTR key);

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK PassphraseDlgProc(HWND hWnd, UINT uMessage,
				WPARAM wParam, LPARAM lParam);
BOOL CALLBACK DialogDlgProc(HWND hWnd, UINT uMessage,
				WPARAM wParam, LPARAM lParam);

extern char *OTP_btoe(char *, char *);
extern int  _otp_MD4_keycrunch(char *, char *, char *);
extern void _otp_MD4_iterate(char *);
extern int  _otp_MD5_keycrunch(char *, char *, char *);
extern void _otp_MD5_iterate(char *);
extern int  _otp_SHA1_keycrunch(char *result, char *seed, char *passwd);
extern void _otp_SHA1_iterate(char *x);

#ifdef	GLOBALS
#define	EXTERN
#else
#define	EXTERN	extern
#endif

EXTERN	int			hash_func;
EXTERN	int			seq;						// Sequence Number
EXTERN	char		seed[SEED_MAX_LEN];			// Seed
EXTERN	char		pass[ONETIME_KEY_MAX_LEN];	// One-Time KEY
EXTERN	int			(* KeyCrunchFunc)(char *, char *, char *);
EXTERN	void		(* IterateFunc)  (char *);
EXTERN	TCHAR		FuncName[16];
EXTERN	LPCTSTR		szAppName;
EXTERN	HINSTANCE	hInst;
EXTERN	HICON		hOTPIcon;
EXTERN	BOOL		bSKeyMD5;
